<?php
namespace Teknisa\DF\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\GER\Modules\Fiscal\Factory;
use Indeterminado\Entities\prodesoneraimfor;
use Indeterminado\Entities\prodesoneraimfil;
use Indeterminado\Entities\prodesoneraimcli;
use Setforms2\Shared\Registry;

class Ger05500ProdutosDesoneracaoImpostosService{
    protected $environment;

    public function __construct($environment) {
        $this->environment = $environment;
    }

    public function deleteProdutosDesoneracao ($row) {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        $nrorg = $this->environment->getNrOrgTrab();
        try {
            $produtosFornecedor = prodesoneraimfor::getObjectsByWhere('NRORG = ? AND CDPRODUTO = ?', array($nrorg, $row["CDPRODUTO"]));

            foreach($produtosFornecedor as $forn) {
                $forn->delete();
            }

            $produtosCliente = prodesoneraimcli::getObjectsByWhere('NRORG = ? AND CDPRODUTO = ?', array($nrorg, $row["CDPRODUTO"]));

            foreach($produtosCliente as $cliente) {
                $cliente->delete();
            }

            $prodesoneraimfil = prodesoneraimfil::getObjectsByWhere('NRORG = ? AND CDPRODUTO = ?', array($nrorg, $row["CDPRODUTO"]));

            foreach($prodesoneraimfil as $filial) {
                $filial->delete();
            }
            $connection->flush();
            $connection->commit();
        }
        catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    /*public function deleteProdutoFornecedor($row, $nrorg){
        try {
            $produtosFornecedor = prodesoneraimfor::getObjectsByWhere('NRORG = ? AND CDPRODUTO = ?', array($nrorg, $row["CDPRODUTO"]));

            foreach($produtosFornecedor as $forn) {
                $forn->delete();
                Registry::getEntityManager()->flush();
            }
        }
        catch (\Exception $e) {
            throw $e;
        }
    }*/
}